Attribute VB_Name = "Module3"
' Dieses Programm dient dazu, aus Outlook-Kontakten eine Datenbank-Datei zu erzeugen,
' deren Format dem des bei von Medion GoPal enthaltenen ContactViewers entspricht.
'
' Geschrieben und getestet wurde es unter XP mit Outlook 2003 und dem ContactViewer
' von GoPal 4.5.
' Es erfordert das Programm SQLITE3.EXE, das ich unter http://www.sqlite.org in der
' Version http://www.sqlite.org/sqlite-3_6_6_2.zip heruntergeladen habe.
'
' Das Programm arbeitet als Outlook-Makro 'ContactsDB' und erzeugt zunchst eine ASCII-Datei mit
' SQL Statements die dann anschlieend mit dem Programm SQLITE3 auf eine Datenbankdatei
' namens 'contacts.db' angewendet werden. Beim Aufruf des Makros ContactsDB muss ein
' Outlook-Kontakte-Order aktiv sein. Sollten bestimmte Eintrge dieses Ordners markiert
' sein werden genau diese in die contacts.db bernommen, falls nichts markiert ist werden
' alle Eintrge des Ordners reingeschrieben.
' Man kann im Code das Verzeichnis in welchem die contacts.db erzeugt wird hart vorgeben;
' falls das nicht gemacht wurde wird der Zielorder abgefragt.
'
' Dieser Code darf von jedermann frei kopiert und weiterverwendet werden. Danke an NavNie
' aus dem Forum www.GoPal-Navigator.de fr die Vorlage des SQL Codes zur Erzeugung der
' Tabellen.
'
' Geschrieben von Christoph Ganz, November 2008

' In diesem Verzeichnist befindet sich das Programm SQLITE3.EXE
Const SQLITE3_PATH      As String = "C:\TEMP"

' So soll die Datei heissen in der die SQL Statements landen
Const SQLFILE_NAME      As String = "CONTACTS.SQL"

' in diesem Verzeichnis wird die SQL-Datei abgelegt
Const TEMP_PATH         As String = "C:\TEMP"

' Der Pfad wo die 'contacts.db' hin soll
' man kann den Pfad weiter unten im Code hart setzen, dann gibt es keinen Dialog zur Eingabe des Pfads
Dim Contactsdb_Path As String

' ein paar Typdeklarationen wie sie den Datenbanktabellen entsprechen
Public Type Person
  Id         As Integer
  SortString As String
  LastName   As String
  FirstName  As String
End Type

Public Type Address
  Id         As Integer
  PersonId   As Integer
  CategoryId As Integer
  CountryId  As String
  PostalCode As String
  CityId     As String
  Street     As String
  Longitude  As Single
  Latitude   As Single
End Type

Public Type Phonenumber
  Id          As Integer
  PersonId    As Integer
  CategoryId  As Integer
  Phonenumber As String
End Type

Public Type City
  Id   As Integer
  City As String
End Type

Public Type Country
  Id      As Integer
  Country As String
End Type

' dann wird der komplette Datenbankinhalt als eine tiefe Struktur deklariert
Public Type Contacts_db
  Persons()        As Person
  MaxPersonID      As Integer
  Addresses()      As Address
  MaxAddressID     As Integer
  Phonenumbers()   As Phonenumber
  MaxPhonenumberID As Integer
  Cities()         As City
  MaxCityID        As Integer
  Countries()      As Country
  MaxCountryID     As Integer
End Type

' Die Kategorien als Konstanten
Const CATEGORY_HOME     As Integer = 1
Const CATEGORY_BUSINESS As Integer = 2
Const CATEGORY_MOBILE   As Integer = 3
Sub ContactsDB()

' Diese Prozedur ist die Haupt-Prozedur. Sie liest die Daten aus den Outlook Kontaktenm, legt die entsprechenden Strukturen
' fr die Datenbank an, schreibt die Datei mit den SQL Statements und fttert SQLITE3.EXE damit

' ein paar Deklarationen die man fr das Auslesen braucht
Dim ns As NameSpace
Dim fld As MAPIFolder
Dim itms As Items
Dim itm
Dim ContactItem As ContactItem
Dim myOlSel As Outlook.Selection
Dim NumberHighlightedContactItems As Integer
Dim retVal

' die Variable die alle Datenbank-Eintrge aufnimmt
Dim mycontactsdb As Contacts_db

' zur Ausfhrung von SQLLITE3.EXE
Dim ShellComand As String

' wie gesagt, wenn man den Pfad im Code setzt gibt es keinen Dialog zur Eingabe
Contactsdb_Path = "C:\TEMP"

' So, zuerst ein paar VBA Sachen
Set ns = Application.GetNamespace("MAPI")

' der aktuelle Ordner muss fr dieses Programm ein 'Kontakte'-Ordner sein
Set fld = Application.ActiveExplorer.CurrentFolder

If Application.ActiveExplorer.Selection.Count > 0 Then
 ' wenn Eintrge selektiert sind, werden nur diese in die Datenbank geschrieben
 
  ' mal nachzhlen wieviele Kontakte tatschlich selektiert sind
  For i = 1 To Application.ActiveExplorer.Selection.Count
    Set itm = Application.ActiveExplorer.Selection.item(i)
    If TypeName(itm) = "ContactItem" Then
      NumberHighlightedContactItems = NumberHighlightedContactItems + 1
    End If
  Next i
 
  If NumberHighlightedContactItems = 0 Then
    MsgBox "Es wurde was selektiert, aber keine Kontakteintrge"
    Exit Sub
  End If
 
  MsgBox "Es werden " & CStr(NumberHighlightedContactItems) _
         & " Kontakteintrge bertragen"

  ' und jetzt fr jeden Eintrag die entsprechenden Strukturen aufbauen
  For i = 1 To Application.ActiveExplorer.Selection.Count
    Set itm = Application.ActiveExplorer.Selection.item(i)
    If TypeName(itm) = "ContactItem" Then
      Set ContactItem = itm
      ' jetzt die eigentliche Arbeit: den Kontakteintrag in die Struktur aufnehmen
      Call AddToDatabase(ContactItem, mycontactsdb)
    End If
  Next i
  
Else

  ' wenn nix ausgewhlt ist werden alle Eintrge des Folders in die DB-Strukturen bertragen
  MsgBox "Es werden alle " + CStr(fld.Items.Count) + " Kontakte aus '" + fld.Name + "' bertragen"

  Set itms = fld.Items
  itms.Sort "[LastName]", False
  For Each itm In itms
    If TypeName(itm) = "ContactItem" Then
      Set ContactItem = itm
      Call AddToDatabase(ContactItem, mycontactsdb)
    End If
  Next itm

End If

' falls der Pfad fr die contacts.db nicht hart festgelegt ist, wird er hier abgefragt
If Contactsdb_Path = "" Then
Set objShell = CreateObject("shell.application")
  sMsg = "Verzeichnis fr 'contacts.db'"
  cBits = 1
  xRoot = 17
  Set objBFF = objShell.BrowseForFolder(0, sMsg, cBits, xRoot)
  Contactsdb_Path = objBFF.self.Path
End If

' So, jetzt SQL-Datei aufmachen
Outstream = 1
Open TEMP_PATH & "\" & SQLFILE_NAME For Output As #Outstream

' die konstanten Statements reinschreiben
Call SqlOutputFixed(Outstream, True)

' die datenabhngigen Statements hinterher
Call SqlOutputdata(Outstream, mycontactsdb)

' COMMIT am Schluss und Datei zumachen
Print #Outstream, "COMMIT;"
Close #Outstream
' MsgBox (TEMP_PATH & "\" & SQLFILE_NAME & " erstellt")

' und dann SLQITE3 ber CMD.EXE starten, als Parameter die Datenbankdatei mitgeben, und CMD.EXE sagen dass der Input aus der SQL-Datei gelesen werden soll
Shellcommand = "CMD.EXE /C " & SQLITE3_PATH & "\" & "SQLITE3.EXE " + Contactsdb_Path + "\contacts.db < " & TEMP_PATH & "\" & SQLFILE_NAME
retVal = Shell(Shellcommand)
' MsgBox ("'" & Shellcommand & "' gestartet")

' Das war's dann

End Sub
' diese Prozedur erweitert die Datenbank-Variable um alle notwendigen Eintrge fr einen ContactItem
Sub AddToDatabase(item As ContactItem, db As Contacts_db)

' zuerst den Eintrag in Persons, den gibt es immer
  db.MaxPersonID = db.MaxPersonID + 1
  ReDim Preserve db.Persons(db.MaxPersonID)
  
  db.Persons(db.MaxPersonID).Id = db.MaxPersonID
  db.Persons(db.MaxPersonID).SortString = item.FileAs
  db.Persons(db.MaxPersonID).LastName = item.LastName
  db.Persons(db.MaxPersonID).FirstName = item.FirstName

' dann fr die jeweilige Telefonnummer
  If item.HomeTelephoneNumber <> "" Then
    db.MaxPhonenumberID = db.MaxPhonenumberID + 1
    ReDim Preserve db.Phonenumbers(db.MaxPhonenumberID)
    db.Phonenumbers(db.MaxPhonenumberID).Id = db.MaxPhonenumberID
    db.Phonenumbers(db.MaxPhonenumberID).PersonId = db.MaxPersonID
    db.Phonenumbers(db.MaxPhonenumberID).CategoryId = CATEGORY_HOME
    db.Phonenumbers(db.MaxPhonenumberID).Phonenumber = item.HomeTelephoneNumber
  End If
  If item.BusinessTelephoneNumber <> "" Then
    db.MaxPhonenumberID = db.MaxPhonenumberID + 1
    ReDim Preserve db.Phonenumbers(db.MaxPhonenumberID)
    db.Phonenumbers(db.MaxPhonenumberID).Id = db.MaxPhonenumberID
    db.Phonenumbers(db.MaxPhonenumberID).PersonId = db.MaxPersonID
    db.Phonenumbers(db.MaxPhonenumberID).CategoryId = CATEGORY_BUSINESS
    db.Phonenumbers(db.MaxPhonenumberID).Phonenumber = item.BusinessTelephoneNumber
  End If
  If item.MobileTelephoneNumber <> "" Then
    db.MaxPhonenumberID = db.MaxPhonenumberID + 1
    ReDim Preserve db.Phonenumbers(db.MaxPhonenumberID)
    db.Phonenumbers(db.MaxPhonenumberID).Id = db.MaxPhonenumberID
    db.Phonenumbers(db.MaxPhonenumberID).PersonId = db.MaxPersonID
    db.Phonenumbers(db.MaxPhonenumberID).CategoryId = CATEGORY_MOBILE
    db.Phonenumbers(db.MaxPhonenumberID).Phonenumber = item.MobileTelephoneNumber
  End If

' zwei Adressen werden bercksichtigt, nmlich Home und Business
  If item.HomeAddress <> "" Then
    db.MaxAddressID = db.MaxAddressID + 1
    ReDim Preserve db.Addresses(db.MaxAddressID)
    db.Addresses(db.MaxAddressID).Id = db.MaxAddressID
    db.Addresses(db.MaxAddressID).PersonId = db.MaxPersonID
    db.Addresses(db.MaxAddressID).CategoryId = CATEGORY_HOME
    ' das Land und die Stadt werden ber Funktionen ermittelt
    db.Addresses(db.MaxAddressID).CountryId = MergeCountry(item.HomeAddressCountry, db)
    db.Addresses(db.MaxAddressID).CityId = MergeCity(item.HomeAddressCity, db)
    db.Addresses(db.MaxAddressID).Street = item.HomeAddressStreet
    db.Addresses(db.MaxAddressID).PostalCode = item.HomeAddressPostalCode
    ' die Koordinaten wei ich nicht...
    db.Addresses(db.MaxAddressID).Longitude = 0
    db.Addresses(db.MaxAddressID).Latitude = 0
  End If
    
  If item.BusinessAddress <> "" Then
    db.MaxAddressID = db.MaxAddressID + 1
    ReDim Preserve db.Addresses(db.MaxAddressID)
    db.Addresses(db.MaxAddressID).Id = db.MaxAddressID
    db.Addresses(db.MaxAddressID).PersonId = db.MaxPersonID
    db.Addresses(db.MaxAddressID).CategoryId = CATEGORY_BUSINESS
    db.Addresses(db.MaxAddressID).CountryId = MergeCountry(item.BusinessAddressCountry, db)
    db.Addresses(db.MaxAddressID).CityId = MergeCity(item.BusinessAddressCity, db)
    db.Addresses(db.MaxAddressID).Street = item.BusinessAddressStreet
    db.Addresses(db.MaxAddressID).PostalCode = item.BusinessAddressPostalCode
    db.Addresses(db.MaxAddressID).Longitude = 0
    db.Addresses(db.MaxAddressID).Latitude = 0
  End If
    
End Sub
' diese Funktion gibt eine ID fr das Land zurck; falls das Land noch nicht in den Strukturen enthalten ist wird es hinzugefgt
Function MergeCountry(Country As String, db As Contacts_db) As String

Dim index As Integer

' "NULL" geht nicht, weil die ID as NOT NULL definiert ist,
' aber "0" scheint ok zu sein auch wenn es keinen Eintrag in der Sekundrtabelle dafr gibt
  If Country = "" Then
    MergeCountry = "0"  ' also 'nicht bekannt'
    Exit Function
  End If
     
  If db.MaxCountryID > 0 Then
    ' zuerst suchen ob das gesuchte Land in der Liste drin ist
    For index = 1 To db.MaxCountryID + 1
      If index <= db.MaxCountryID Then
        If db.Countries(index).Country = Country Then
          ' und in String gewandelt zurckgeben
          MergeCountry = CStr(index)
          Exit For
        End If
      End If
    Next index
  End If
  ' Wenn bis dato nix gefunden wurde, die 'Country'-Tabelle erweitern und den neuen letzten Index zurckgeben
  If MergeCountry = "" Then
    db.MaxCountryID = db.MaxCountryID + 1
    ReDim Preserve db.Countries(db.MaxCountryID)
    db.Countries(db.MaxCountryID).Id = db.MaxCountryID
    db.Countries(db.MaxCountryID).Country = Country
    MergeCountry = CStr(db.MaxCountryID)
  End If
   
End Function
' diese Funktion gibt eine ID fr die Stadt zurck; falls sie noch nicht in den Strukturen enthalten ist wird sie hinzugefgt
' Logik analog zu den Lndern
Function MergeCity(City As String, db As Contacts_db) As String

Dim index As Integer

  If City = "" Then
    MergeCity = "0"
    Exit Function
  End If
     
  If db.MaxCityID > 0 Then
    For index = 1 To db.MaxCityID
        If db.Cities(index).City = City Then
          MergeCity = CStr(index)
          Exit For
        End If
    Next index
  End If
  If MergeCity = "" Then
    db.MaxCityID = db.MaxCityID + 1
    ReDim Preserve db.Cities(db.MaxCityID)
    db.Cities(db.MaxCityID).Id = db.MaxCityID
    db.Cities(db.MaxCityID).City = City
    MergeCity = CStr(db.MaxCityID)
  End If
     
End Function
' diese Prozedur schreibt die datenabhngigen SQL Statements in die Datei
Sub SqlOutputdata(Outstream, db As Contacts_db)

Dim i As Integer
    
  For i = 1 To db.MaxPersonID
    Print #Outstream, "INSERT INTO " & Chr$(34) & "Persons" & Chr$(34) & " VALUES(" & db.Persons(i).Id & ",'" & db.Persons(i).SortString & _
                      "', '" & db.Persons(i).LastName & "', '" & db.Persons(i).FirstName & "');"
  Next i

  For i = 1 To db.MaxAddressID
    Print #Outstream, "INSERT INTO " & Chr$(34) & "Addresses" & Chr$(34) & " VALUES(" & db.Addresses(i).Id & ", " & db.Addresses(i).PersonId & _
                      ", " & db.Addresses(i).CategoryId & ", " & db.Addresses(i).CountryId & ", '" & db.Addresses(i).PostalCode & _
                      "', " & db.Addresses(i).CityId & ", '" & db.Addresses(i).Street & _
                      "', " & "NULL" & ", " & "NULL" & " );"
                      ' Wenn man die Koordinaten wei, kann man die als 'Latitude' und 'Longitude' -Werte in die SQL Datei reinschreiben,
                      ' aber wenn nicht muss man NULL in die DB eingeben. '0' '0' geht nmlich nicht, ist vermutlich der Nordpol...
                      ' "', '" & db.Addresses(i).Longitude & "', '" & db.Addresses(i).Latitude & "');"
  Next i

  For i = 1 To db.MaxPhonenumberID
    ' bei den Telefonnummern macht es anscheinend nix wenn da Leerzeichen, Klammern, '+'-Zeichen etc. drin sind, es wird korrekt gewhlt
    Print #Outstream, "INSERT INTO " & Chr$(34) & "Phonenumbers" & Chr$(34) & " VALUES(" & db.Phonenumbers(i).Id & "," & db.Phonenumbers(i).PersonId & _
                      ", " & db.Phonenumbers(i).CategoryId & ", '" & db.Phonenumbers(i).Phonenumber & "');"
  Next i

  For i = 1 To db.MaxCityID
    Print #Outstream, "INSERT INTO " & Chr$(34) & "Cities" & Chr$(34) & " VALUES(" & db.Cities(i).Id & ",'" & db.Cities(i).City & "');"
  Next i

  For i = 1 To db.MaxCountryID
    Print #Outstream, "INSERT INTO " & Chr$(34) & "Countries" & Chr$(34) & " VALUES(" & db.Countries(i).Id & ",'" & db.Countries(i).Country & "');"
  Next i

End Sub
' diese Prozedur schreibt die von den Daten unabhngigen SQL Statements in die Datei
Sub SqlOutputFixed(Outstream, fileexists As Boolean)

  Print #Outstream, "BEGIN TRANSACTION;"

'   Die ganzen DROP TABLES vermeiden Fehler wenn man ein CREATE TABLE fr eine bereits gefllte contacts.db machen will.
'   Im interaktiven Fall ergeben die DROP TABLES Warnungen wenn man eine leere oder neue contacts.db schreiben will, aber
'   im Hintergrund merkt man davon nix, daher werden sie vorerst immer mit erzeugt
  If fileexists = True Then
    Print #Outstream, "DROP TABLE About;"
    Print #Outstream, "DROP TABLE Persons;"
    Print #Outstream, "DROP TABLE Addresses;"
    Print #Outstream, "DROP TABLE Phonenumbers;"
    Print #Outstream, "DROP TABLE Categories;"
    Print #Outstream, "DROP TABLE Countries;"
    Print #Outstream, "DROP TABLE Cities;"
    Print #Outstream, "DROP TABLE ContactHistory;"
    Print #Outstream, "DROP TABLE LastSelection;"
    Print #Outstream, "DROP VIEW ResolvedAddresses;"
    Print #Outstream, "DROP VIEW PersonalAddresses;"
    Print #Outstream, "DROP VIEW PersonalPhonenumbers;"
  End If

  Print #Outstream, "CREATE TABLE About (Version integer NOT NULL,Timestamp blob NOT NULL);"
  Print #Outstream, "CREATE TABLE Persons (Id integer PRIMARY KEY NOT NULL,  SortString varchar(50) NOT NULL,  LastName   varchar(50) NOT NULL,  FirstName  varchar(50) NOT NULL);"
  Print #Outstream, "CREATE TABLE Addresses (Id integer PRIMARY KEY  NOT NULL,PersonId integer NOT NULL,CategoryId  integer NOT NULL,  CountryId   integer NOT NULL,  PostalCode  varchar(10),  CityId      integer NOT NULL,  Street      varchar(50) NOT NULL,  Longitude   float(50),  Latitude    float(50));"
  Print #Outstream, "CREATE TABLE Phonenumbers (Id integer PRIMARY KEY  NOT NULL,PersonId integer NOT NULL,CategoryId integer NOT NULL,  Phonenumber varchar(50) NOT NULL);"
  Print #Outstream, "CREATE TABLE Categories (  Id        integer PRIMARY KEY  NOT NULL,  Category  varchar(50) NOT NULL);"
  Print #Outstream, "CREATE TABLE Countries (  Id       integer PRIMARY KEY  NOT NULL,  Country  varchar(50) NOT NULL);"
  Print #Outstream, "CREATE TABLE Cities (  Id    integer PRIMARY KEY NOT NULL,  City  varchar(50) NOT NULL);"
  Print #Outstream, "CREATE TABLE ContactHistory ( Id integer, PosNr integer );"
  Print #Outstream, "CREATE TABLE LastSelection ( PersonId integer PRIMARY KEY , PhoneId integer, AddressId integer );"

  Print #Outstream, "CREATE VIEW ResolvedAddresses AS SELECT Addresses.Id AS Id,  Addresses.PersonId AS PersonId,  Addresses.CategoryId AS CategoryId,";
  Print #Outstream, "Countries.Country  AS Country,  Addresses.PostalCode AS PostalCode,  Cities.City AS City,  Addresses.Street AS Street,  Addresses.Longitude AS Longitude,Addresses.Latitude AS Latitude ";
  Print #Outstream, "FROM   Addresses   INNER JOIN Countries ON (Addresses.CountryId=Countries.Id)  INNER JOIN Cities ON (Addresses.CityId=Cities.Id);"

  Print #Outstream, "CREATE VIEW PersonalAddresses AS SELECT   Persons.Id AS PersonId,   Persons.SortString AS SortString,  Persons.LastName AS LastName,";
  Print #Outstream, "Persons.FirstName AS FirstName,  Addresses.CategoryId AS CategoryId,  Countries.Country AS Country,  Addresses.PostalCode AS PostalCode,  Cities.City AS City,";
  Print #Outstream, "Addresses.Street AS Street,  Addresses.Longitude AS Longitude,  Addresses.Latitude AS Latitude ";
  Print #Outstream, "FROM   Persons   INNER JOIN Addresses ON (Addresses.PersonId=Persons.Id)  INNER JOIN Countries ON (Addresses.CountryId=Countries.Id)  INNER JOIN Cities ON (Addresses.CityId=Cities.Id);"

  Print #Outstream, "CREATE VIEW PersonalPhonenumbers AS SELECT   Persons.Id AS PersonId,  Persons.SortString AS SortString,  Persons.LastName AS LastName,";
  Print #Outstream, "Persons.FirstName AS FirstName,  Phonenumbers.CategoryId AS CategoryId,  Phonenumbers.Phonenumber AS Phonenumber ";
  Print #Outstream, "FROM   Persons   INNER JOIN Phonenumbers ON (Phonenumbers.PersonId=Persons.Id);"

  Print #Outstream, "INSERT INTO " & Chr$(34) & "Categories" & Chr$(34) & " VALUES(" & CATEGORY_HOME & ", 'Home');"
  Print #Outstream, "INSERT INTO " & Chr$(34) & "Categories" & Chr$(34) & " VALUES(" & CATEGORY_BUSINESS & ", 'Business');"
  Print #Outstream, "INSERT INTO " & Chr$(34) & "Categories" & Chr$(34) & " VALUES(" & CATEGORY_MOBILE & ", 'Mobile');"

  Print #Outstream, "INSERT INTO " & Chr$(34) & "LastSelection" & Chr$(34) & " Values(1, 1, 1);"

  Print #Outstream, "INSERT INTO " & Chr$(34) & "ContactHistory" & Chr$(34) & " Values(1, 0);"

  Print #Outstream, "INSERT INTO " & Chr$(34) & "About" & Chr$(34) & " VALUES(1, X'D707090001001100130005001B00B003');"

End Sub
